Package org.eclipse.viatra.query.patternlanguage.emf.serializer

## Class AbstractEMFPatternLanguageSemanticSequencer

- java.lang.Object
- - org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer
  - - org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer
    - - org.eclipse.xtext.xbase.serializer.AbstractXtypeSemanticSequencer
      - - org.eclipse.xtext.xbase.serializer.XtypeSemanticSequencer
        - - org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer
          - - org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer
            - - org.eclipse.viatra.query.patternlanguage.emf.serializer.AbstractEMFPatternLanguageSemanticSequencer

- All Implemented Interfaces:
    `org.eclipse.xtext.serializer.sequencer.ISemanticSequencer`
  Direct Known Subclasses:
    `EMFPatternLanguageSemanticSequencer`

      public abstract class AbstractEMFPatternLanguageSemanticSequencer
      extends org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

      `OPERATOR_NOT_SUPPORTED`

    - ### Fields inherited from class org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer

      `genericSequencer, genericSequencerProvider`

    - ### Fields inherited from class org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer

      `diagnosticProvider, errorAcceptor, feederProvider, masterSequencer, nodeProvider, sequenceAcceptor, transientValues`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractEMFPatternLanguageSemanticSequencer()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `sequence​(org.eclipse.xtext.serializer.ISerializationContext context, org.eclipse.emf.ecore.EObject semanticObject)` |
    `protected void` | `sequence_AggregatedValue​(org.eclipse.xtext.serializer.ISerializationContext context, AggregatedValue semanticObject)` | Contexts: ValueReference returns AggregatedValue AnnotationValueReference returns AggregatedValue ComputationValue returns AggregatedValue AggregatedValue returns AggregatedValue Constraint: (aggregator=[JvmDeclaredType|ValidID] (call=PatternCall | call=EClassifierConstraint | call=PathExpressionConstraint))
    `protected void` | `sequence_Annotation​(org.eclipse.xtext.serializer.ISerializationContext context, Annotation semanticObject)` | Contexts: Annotation returns Annotation Constraint: (name=ID (parameters+=AnnotationParameter parameters+=AnnotationParameter*)?)
    `protected void` | `sequence_AnnotationParameter​(org.eclipse.xtext.serializer.ISerializationContext context, AnnotationParameter semanticObject)` | Contexts: AnnotationParameter returns AnnotationParameter Constraint: (name=ID value=AnnotationValueReference)
    `protected void` | `sequence_BoolValue​(org.eclipse.xtext.serializer.ISerializationContext context, BoolValue semanticObject)` | Contexts: ValueReference returns BoolValue AnnotationValueReference returns BoolValue LiteralValueReference returns BoolValue BoolValue returns BoolValue Constraint: value=XBooleanLiteral
    `protected void` | `sequence_CheckConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, CheckConstraint semanticObject)` | Contexts: Constraint returns CheckConstraint CheckConstraint returns CheckConstraint Constraint: expression=XExpression
    `protected void` | `sequence_CompareConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, CompareConstraint semanticObject)` | Contexts: Constraint returns CompareConstraint CompareConstraint returns CompareConstraint Constraint: (leftOperand=ValueReference feature=CompareFeature rightOperand=ValueReference)
    `protected void` | `sequence_EClassifierConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, EClassifierConstraint semanticObject)` | Contexts: Constraint returns EClassifierConstraint EClassifierConstraint returns EClassifierConstraint Constraint: (type=Type var=VariableReference)
    `protected void` | `sequence_EnumValue​(org.eclipse.xtext.serializer.ISerializationContext context, EnumValue semanticObject)` | Contexts: ValueReference returns EnumValue AnnotationValueReference returns EnumValue LiteralValueReference returns EnumValue EnumValue returns EnumValue Constraint: (enumeration=[EEnum|ID]? literal=[EEnumLiteral|ID])
    `protected void` | `sequence_FunctionEvaluationValue​(org.eclipse.xtext.serializer.ISerializationContext context, FunctionEvaluationValue semanticObject)` | Contexts: ValueReference returns FunctionEvaluationValue AnnotationValueReference returns FunctionEvaluationValue ComputationValue returns FunctionEvaluationValue FunctionEvaluationValue returns FunctionEvaluationValue Constraint: (unwind?='unwind'? expression=XExpression)
    `protected void` | `sequence_JavaConstantValue​(org.eclipse.xtext.serializer.ISerializationContext context, JavaConstantValue semanticObject)` | Contexts: ValueReference returns JavaConstantValue AnnotationValueReference returns JavaConstantValue LiteralValueReference returns JavaConstantValue JavaConstantValue returns JavaConstantValue Constraint: (classRef=[JvmDeclaredType|QualifiedName] fieldRef=[JvmField|ID])
    `protected void` | `sequence_JavaType​(org.eclipse.xtext.serializer.ISerializationContext context, JavaType semanticObject)` | Contexts: JavaType returns JavaType Constraint: classRef=[JvmDeclaredType|QualifiedName]
    `protected void` | `sequence_ListValue​(org.eclipse.xtext.serializer.ISerializationContext context, ListValue semanticObject)` | Contexts: AnnotationValueReference returns ListValue ListValue returns ListValue Constraint: (values+=ValueReference values+=ValueReference*)
    `protected void` | `sequence_Modifiers​(org.eclipse.xtext.serializer.ISerializationContext context, Modifiers semanticObject)` | Contexts: Modifiers returns Modifiers Constraint: (private?='private' | execution=ExecutionTypeModifier)*
    `protected void` | `sequence_NumberValue​(org.eclipse.xtext.serializer.ISerializationContext context, NumberValue semanticObject)` | Contexts: ValueReference returns NumberValue AnnotationValueReference returns NumberValue LiteralValueReference returns NumberValue NumberValue returns NumberValue Constraint: (negative?='-'? value=XNumberLiteral)
    `protected void` | `sequence_PackageImport​(org.eclipse.xtext.serializer.ISerializationContext context, PackageImport semanticObject)` | Contexts: PackageImport returns PackageImport Constraint: (ePackage=[EPackage|STRING] alias=ID?)
    `protected void` | `sequence_Parameter​(org.eclipse.xtext.serializer.ISerializationContext context, Parameter semanticObject)` | Contexts: Parameter returns Parameter Constraint: (direction=ParameterDirectionModifier? name=ID (type=Type | type=JavaType)?)
    `protected void` | `sequence_PathExpressionConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, PathExpressionConstraint semanticObject)` | Contexts: Constraint returns PathExpressionConstraint PathExpressionConstraint returns PathExpressionConstraint Constraint: (sourceType=Type edgeTypes+=RefType* transitive=ClosureType? src=VariableReference dst=ValueReference)
    `protected void` | `sequence_Pattern​(org.eclipse.xtext.serializer.ISerializationContext context, Pattern semanticObject)` | Contexts: Pattern returns Pattern Constraint: ( annotations+=Annotation* modifiers=Modifiers name=ID (parameters+=Parameter parameters+=Parameter*)? bodies+=PatternBody bodies+=PatternBody* )
    `protected void` | `sequence_PatternBody​(org.eclipse.xtext.serializer.ISerializationContext context, PatternBody semanticObject)` | Contexts: PatternBody returns PatternBody Constraint: (name=ID? constraints+=Constraint*)
    `protected void` | `sequence_PatternCall​(org.eclipse.xtext.serializer.ISerializationContext context, PatternCall semanticObject)` | Contexts: PatternCall returns PatternCall Constraint: (patternRef=[Pattern|QualifiedName] transitive=ClosureType? (parameters+=ValueReference parameters+=ValueReference*)?)
    `protected void` | `sequence_PatternCompositionConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, PatternCompositionConstraint semanticObject)` | Contexts: Constraint returns PatternCompositionConstraint PatternCompositionConstraint returns PatternCompositionConstraint Constraint: ((negative?='neg'? call=PatternCall) | (negative?='neg' (call=EClassifierConstraint | call=PathExpressionConstraint)))
    `protected void` | `sequence_PatternImport​(org.eclipse.xtext.serializer.ISerializationContext context, PatternImport semanticObject)` | Contexts: PatternImport returns PatternImport Constraint: pattern=[Pattern|QualifiedName]
    `protected void` | `sequence_PatternModel​(org.eclipse.xtext.serializer.ISerializationContext context, PatternModel semanticObject)` | Contexts: PatternModel returns PatternModel Constraint: (packageName=QualifiedName? importPackages=VQLImportSection patterns+=Pattern*)
    `protected void` | `sequence_RefType​(org.eclipse.xtext.serializer.ISerializationContext context, ReferenceType semanticObject)` | Contexts: RefType returns ReferenceType Constraint: refname=[EStructuralFeature|ID]
    `protected void` | `sequence_StringValue​(org.eclipse.xtext.serializer.ISerializationContext context, StringValue semanticObject)` | Contexts: ValueReference returns StringValue AnnotationValueReference returns StringValue LiteralValueReference returns StringValue StringValue returns StringValue Constraint: value=STRING
    `protected void` | `sequence_Type​(org.eclipse.xtext.serializer.ISerializationContext context, ClassType semanticObject)` | Contexts: Type returns ClassType Constraint: (metamodel=[PackageImport|ID]? classname=[EClassifier|ID])
    `protected void` | `sequence_TypeCheckConstraint​(org.eclipse.xtext.serializer.ISerializationContext context, TypeCheckConstraint semanticObject)` | Contexts: Constraint returns TypeCheckConstraint TypeCheckConstraint returns TypeCheckConstraint Constraint: (type=JavaType var=VariableReference)
    `protected void` | `sequence_VariableReference​(org.eclipse.xtext.serializer.ISerializationContext context, VariableReference semanticObject)` | Contexts: VariableReference returns VariableReference ValueReference returns VariableReference AnnotationValueReference returns VariableReference Constraint: ((aggregator?='#'? var=ID) | aggregator?='#')
    `protected void` | `sequence_VQLImportSection​(org.eclipse.xtext.serializer.ISerializationContext context, VQLImportSection semanticObject)` | Contexts: VQLImportSection returns VQLImportSection Constraint: (packageImport+=PackageImport | patternImport+=PatternImport | importDeclarations+=XImportDeclaration)*
    `protected void` | `sequence_XBooleanLiteral​(org.eclipse.xtext.serializer.ISerializationContext context, org.eclipse.xtext.xbase.XBooleanLiteral semanticObject)` | Contexts: XBooleanLiteral returns XBooleanLiteral XExpression returns XBooleanLiteral XAssignment returns XBooleanLiteral XAssignment.XBinaryOperation_1_1_0_0_0 returns XBooleanLiteral XOrExpression returns XBooleanLiteral XOrExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XAndExpression returns XBooleanLiteral XAndExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XEqualityExpression returns XBooleanLiteral XEqualityExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XRelationalExpression returns XBooleanLiteral XRelationalExpression.XInstanceOfExpression_1_0_0_0_0 returns XBooleanLiteral XRelationalExpression.XBinaryOperation_1_1_0_0_0 returns XBooleanLiteral XOtherOperatorExpression returns XBooleanLiteral XOtherOperatorExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XAdditiveExpression returns XBooleanLiteral XAdditiveExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XMultiplicativeExpression returns XBooleanLiteral XMultiplicativeExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral XUnaryOperation returns XBooleanLiteral XCastedExpression returns XBooleanLiteral XCastedExpression.XCastedExpression_1_0_0_0 returns XBooleanLiteral XPostfixOperation returns XBooleanLiteral XPostfixOperation.XPostfixOperation_1_0_0 returns XBooleanLiteral XMemberFeatureCall returns XBooleanLiteral XMemberFeatureCall.XAssignment_1_0_0_0_0 returns XBooleanLiteral XMemberFeatureCall.XMemberFeatureCall_1_1_0_0_0 returns XBooleanLiteral XPrimaryExpression returns XBooleanLiteral XLiteral returns XBooleanLiteral XParenthesizedExpression returns XBooleanLiteral XExpressionOrVarDeclaration returns XBooleanLiteral Constraint: (isTrue?='true' | isTrue?='TRUE')?
    `protected void` | `sequence_XImportDeclaration​(org.eclipse.xtext.serializer.ISerializationContext context, org.eclipse.xtext.xtype.XImportDeclaration semanticObject)` | Contexts: XImportDeclaration returns XImportDeclaration Constraint: ( (static?='static' extension?='extension'? importedType=[JvmDeclaredType|QualifiedName]) | importedType=[JvmDeclaredType|QualifiedName] | importedNamespace=QualifiedNameWithWildcard )
    `protected void` | `sequence_XNumberLiteral​(org.eclipse.xtext.serializer.ISerializationContext context, org.eclipse.xtext.xbase.XNumberLiteral semanticObject)` | Contexts: XNumberLiteral returns XNumberLiteral XExpression returns XNumberLiteral XAssignment returns XNumberLiteral XAssignment.XBinaryOperation_1_1_0_0_0 returns XNumberLiteral XOrExpression returns XNumberLiteral XOrExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XAndExpression returns XNumberLiteral XAndExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XEqualityExpression returns XNumberLiteral XEqualityExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XRelationalExpression returns XNumberLiteral XRelationalExpression.XInstanceOfExpression_1_0_0_0_0 returns XNumberLiteral XRelationalExpression.XBinaryOperation_1_1_0_0_0 returns XNumberLiteral XOtherOperatorExpression returns XNumberLiteral XOtherOperatorExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XAdditiveExpression returns XNumberLiteral XAdditiveExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XMultiplicativeExpression returns XNumberLiteral XMultiplicativeExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral XUnaryOperation returns XNumberLiteral XCastedExpression returns XNumberLiteral XCastedExpression.XCastedExpression_1_0_0_0 returns XNumberLiteral XPostfixOperation returns XNumberLiteral XPostfixOperation.XPostfixOperation_1_0_0 returns XNumberLiteral XMemberFeatureCall returns XNumberLiteral XMemberFeatureCall.XAssignment_1_0_0_0_0 returns XNumberLiteral XMemberFeatureCall.XMemberFeatureCall_1_1_0_0_0 returns XNumberLiteral XPrimaryExpression returns XNumberLiteral XLiteral returns XNumberLiteral XParenthesizedExpression returns XNumberLiteral XExpressionOrVarDeclaration returns XNumberLiteral Constraint: value=Number

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

      `getValidOperator, isBuilderSyntax, isBuilderSyntax, isXShortClosure, isXShortClosure, isXShortClosureAndBuilderSyntax, sequence_XAdditiveExpression, sequence_XAdditiveExpression_XAndExpression_XAssignment_XEqualityExpression_XMultiplicativeExpression_XOrExpression_XOtherOperatorExpression_XRelationalExpression, sequence_XAssignment, sequence_XConstructorCall, sequence_XExpression, sequence_XFeatureCall, sequence_XMemberFeatureCall`

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer

      `sequence_FullJvmFormalParameter, sequence_FullJvmFormalParameter, sequence_JvmFormalParameter, sequence_JvmFormalParameter, sequence_XAdditiveExpression_XAndExpression_XAssignment_XEqualityExpression_XMultiplicativeExpression_XOrExpression_XOtherOperatorExpression_XRelationalExpression, sequence_XAssignment_XMemberFeatureCall, sequence_XAssignment_XMemberFeatureCall, sequence_XBasicForLoopExpression, sequence_XBasicForLoopExpression, sequence_XBlockExpression, sequence_XBlockExpression, sequence_XBooleanLiteral, sequence_XCasePart, sequence_XCasePart, sequence_XCastedExpression, sequence_XCastedExpression, sequence_XCatchClause, sequence_XCatchClause, sequence_XClosure, sequence_XClosure, sequence_XConstructorCall, sequence_XDoWhileExpression, sequence_XDoWhileExpression, sequence_XExpressionInClosure, sequence_XExpressionInClosure, sequence_XFeatureCall, sequence_XForLoopExpression, sequence_XForLoopExpression, sequence_XIfExpression, sequence_XIfExpression, sequence_XListLiteral, sequence_XListLiteral, sequence_XMemberFeatureCall, sequence_XNullLiteral, sequence_XNullLiteral, sequence_XNumberLiteral, sequence_XPostfixOperation, sequence_XPostfixOperation, sequence_XRelationalExpression, sequence_XRelationalExpression, sequence_XReturnExpression, sequence_XReturnExpression, sequence_XSetLiteral, sequence_XSetLiteral, sequence_XShortClosure, sequence_XShortClosure, sequence_XStringLiteral, sequence_XStringLiteral, sequence_XSwitchExpression, sequence_XSwitchExpression, sequence_XSynchronizedExpression, sequence_XSynchronizedExpression, sequence_XThrowExpression, sequence_XThrowExpression, sequence_XTryCatchFinallyExpression, sequence_XTryCatchFinallyExpression, sequence_XTypeLiteral, sequence_XTypeLiteral, sequence_XUnaryOperation, sequence_XUnaryOperation, sequence_XVariableDeclaration, sequence_XVariableDeclaration, sequence_XWhileExpression, sequence_XWhileExpression`

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.AbstractXtypeSemanticSequencer

      `sequence_JvmLowerBound, sequence_JvmLowerBound, sequence_JvmLowerBoundAnded, sequence_JvmLowerBoundAnded, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference_JvmInnerTypeReference_1_4_0_0_0, sequence_JvmParameterizedTypeReference_JvmInnerTypeReference_1_4_0_0_0, sequence_JvmTypeParameter, sequence_JvmTypeParameter, sequence_JvmTypeReference, sequence_JvmTypeReference, sequence_JvmUpperBound, sequence_JvmUpperBound, sequence_JvmUpperBoundAnded, sequence_JvmUpperBoundAnded, sequence_JvmWildcardTypeReference, sequence_JvmWildcardTypeReference, sequence_XFunctionTypeRef, sequence_XFunctionTypeRef, sequence_XImportDeclaration, sequence_XImportSection, sequence_XImportSection`

    - ### Methods inherited from class org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer

      `init`

    - ### Methods inherited from class org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer

      `createContext, createNodeProvider, createSequence, createSequence, createSequencerFeeder, createSequencerFeeder, createSequencerFeeder, createSequencerFeeder, init, setMasterSequencer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractEMFPatternLanguageSemanticSequencer

          public AbstractEMFPatternLanguageSemanticSequencer()

  - ### Method Detail

    - #### sequence

          public void sequence​(org.eclipse.xtext.serializer.ISerializationContext context,
                               org.eclipse.emf.ecore.EObject semanticObject)

      Overrides:
        `sequence` in class `org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer`

    - #### sequence_AggregatedValue

          protected void sequence_AggregatedValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                  AggregatedValue semanticObject)

           Contexts:
               ValueReference returns AggregatedValue
               AnnotationValueReference returns AggregatedValue
               ComputationValue returns AggregatedValue
               AggregatedValue returns AggregatedValue

           Constraint:
               (aggregator=[JvmDeclaredType|ValidID] (call=PatternCall | call=EClassifierConstraint | call=PathExpressionConstraint))

    - #### sequence_AnnotationParameter

          protected void sequence_AnnotationParameter​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                      AnnotationParameter semanticObject)

           Contexts:
               AnnotationParameter returns AnnotationParameter

           Constraint:
               (name=ID value=AnnotationValueReference)

    - #### sequence_Annotation

          protected void sequence_Annotation​(org.eclipse.xtext.serializer.ISerializationContext context,
                                             Annotation semanticObject)

           Contexts:
               Annotation returns Annotation

           Constraint:
               (name=ID (parameters+=AnnotationParameter parameters+=AnnotationParameter*)?)

    - #### sequence_BoolValue

          protected void sequence_BoolValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                            BoolValue semanticObject)

           Contexts:
               ValueReference returns BoolValue
               AnnotationValueReference returns BoolValue
               LiteralValueReference returns BoolValue
               BoolValue returns BoolValue

           Constraint:
               value=XBooleanLiteral

    - #### sequence_CheckConstraint

          protected void sequence_CheckConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                  CheckConstraint semanticObject)

           Contexts:
               Constraint returns CheckConstraint
               CheckConstraint returns CheckConstraint

           Constraint:
               expression=XExpression

    - #### sequence_CompareConstraint

          protected void sequence_CompareConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                    CompareConstraint semanticObject)

           Contexts:
               Constraint returns CompareConstraint
               CompareConstraint returns CompareConstraint

           Constraint:
               (leftOperand=ValueReference feature=CompareFeature rightOperand=ValueReference)

    - #### sequence_EClassifierConstraint

          protected void sequence_EClassifierConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                        EClassifierConstraint semanticObject)

           Contexts:
               Constraint returns EClassifierConstraint
               EClassifierConstraint returns EClassifierConstraint

           Constraint:
               (type=Type var=VariableReference)

    - #### sequence_EnumValue

          protected void sequence_EnumValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                            EnumValue semanticObject)

           Contexts:
               ValueReference returns EnumValue
               AnnotationValueReference returns EnumValue
               LiteralValueReference returns EnumValue
               EnumValue returns EnumValue

           Constraint:
               (enumeration=[EEnum|ID]? literal=[EEnumLiteral|ID])

    - #### sequence_FunctionEvaluationValue

          protected void sequence_FunctionEvaluationValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                          FunctionEvaluationValue semanticObject)

           Contexts:
               ValueReference returns FunctionEvaluationValue
               AnnotationValueReference returns FunctionEvaluationValue
               ComputationValue returns FunctionEvaluationValue
               FunctionEvaluationValue returns FunctionEvaluationValue

           Constraint:
               (unwind?='unwind'? expression=XExpression)

    - #### sequence_JavaConstantValue

          protected void sequence_JavaConstantValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                    JavaConstantValue semanticObject)

           Contexts:
               ValueReference returns JavaConstantValue
               AnnotationValueReference returns JavaConstantValue
               LiteralValueReference returns JavaConstantValue
               JavaConstantValue returns JavaConstantValue

           Constraint:
               (classRef=[JvmDeclaredType|QualifiedName] fieldRef=[JvmField|ID])

    - #### sequence_JavaType

          protected void sequence_JavaType​(org.eclipse.xtext.serializer.ISerializationContext context,
                                           JavaType semanticObject)

           Contexts:
               JavaType returns JavaType

           Constraint:
               classRef=[JvmDeclaredType|QualifiedName]

    - #### sequence_ListValue

          protected void sequence_ListValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                            ListValue semanticObject)

           Contexts:
               AnnotationValueReference returns ListValue
               ListValue returns ListValue

           Constraint:
               (values+=ValueReference values+=ValueReference*)

    - #### sequence_Modifiers

          protected void sequence_Modifiers​(org.eclipse.xtext.serializer.ISerializationContext context,
                                            Modifiers semanticObject)

           Contexts:
               Modifiers returns Modifiers

           Constraint:
               (private?='private' | execution=ExecutionTypeModifier)*

    - #### sequence_NumberValue

          protected void sequence_NumberValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                              NumberValue semanticObject)

           Contexts:
               ValueReference returns NumberValue
               AnnotationValueReference returns NumberValue
               LiteralValueReference returns NumberValue
               NumberValue returns NumberValue

           Constraint:
               (negative?='-'? value=XNumberLiteral)

    - #### sequence_PackageImport

          protected void sequence_PackageImport​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                PackageImport semanticObject)

           Contexts:
               PackageImport returns PackageImport

           Constraint:
               (ePackage=[EPackage|STRING] alias=ID?)

    - #### sequence_Parameter

          protected void sequence_Parameter​(org.eclipse.xtext.serializer.ISerializationContext context,
                                            Parameter semanticObject)

           Contexts:
               Parameter returns Parameter

           Constraint:
               (direction=ParameterDirectionModifier? name=ID (type=Type | type=JavaType)?)

    - #### sequence_PathExpressionConstraint

          protected void sequence_PathExpressionConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                           PathExpressionConstraint semanticObject)

           Contexts:
               Constraint returns PathExpressionConstraint
               PathExpressionConstraint returns PathExpressionConstraint

           Constraint:
               (sourceType=Type edgeTypes+=RefType* transitive=ClosureType? src=VariableReference dst=ValueReference)

    - #### sequence_PatternBody

          protected void sequence_PatternBody​(org.eclipse.xtext.serializer.ISerializationContext context,
                                              PatternBody semanticObject)

           Contexts:
               PatternBody returns PatternBody

           Constraint:
               (name=ID? constraints+=Constraint*)

    - #### sequence_PatternCall

          protected void sequence_PatternCall​(org.eclipse.xtext.serializer.ISerializationContext context,
                                              PatternCall semanticObject)

           Contexts:
               PatternCall returns PatternCall

           Constraint:
               (patternRef=[Pattern|QualifiedName] transitive=ClosureType? (parameters+=ValueReference parameters+=ValueReference*)?)

    - #### sequence_PatternCompositionConstraint

          protected void sequence_PatternCompositionConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                               PatternCompositionConstraint semanticObject)

           Contexts:
               Constraint returns PatternCompositionConstraint
               PatternCompositionConstraint returns PatternCompositionConstraint

           Constraint:
               ((negative?='neg'? call=PatternCall) | (negative?='neg' (call=EClassifierConstraint | call=PathExpressionConstraint)))

    - #### sequence_PatternImport

          protected void sequence_PatternImport​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                PatternImport semanticObject)

           Contexts:
               PatternImport returns PatternImport

           Constraint:
               pattern=[Pattern|QualifiedName]

    - #### sequence_PatternModel

          protected void sequence_PatternModel​(org.eclipse.xtext.serializer.ISerializationContext context,
                                               PatternModel semanticObject)

           Contexts:
               PatternModel returns PatternModel

           Constraint:
               (packageName=QualifiedName? importPackages=VQLImportSection patterns+=Pattern*)

    - #### sequence_Pattern

          protected void sequence_Pattern​(org.eclipse.xtext.serializer.ISerializationContext context,
                                          Pattern semanticObject)

           Contexts:
               Pattern returns Pattern

           Constraint:
               (
                   annotations+=Annotation*
                   modifiers=Modifiers
                   name=ID
                   (parameters+=Parameter parameters+=Parameter*)?
                   bodies+=PatternBody
                   bodies+=PatternBody*
               )

    - #### sequence_RefType

          protected void sequence_RefType​(org.eclipse.xtext.serializer.ISerializationContext context,
                                          ReferenceType semanticObject)

           Contexts:
               RefType returns ReferenceType

           Constraint:
               refname=[EStructuralFeature|ID]

    - #### sequence_StringValue

          protected void sequence_StringValue​(org.eclipse.xtext.serializer.ISerializationContext context,
                                              StringValue semanticObject)

           Contexts:
               ValueReference returns StringValue
               AnnotationValueReference returns StringValue
               LiteralValueReference returns StringValue
               StringValue returns StringValue

           Constraint:
               value=STRING

    - #### sequence_TypeCheckConstraint

          protected void sequence_TypeCheckConstraint​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                      TypeCheckConstraint semanticObject)

           Contexts:
               Constraint returns TypeCheckConstraint
               TypeCheckConstraint returns TypeCheckConstraint

           Constraint:
               (type=JavaType var=VariableReference)

    - #### sequence_Type

          protected void sequence_Type​(org.eclipse.xtext.serializer.ISerializationContext context,
                                       ClassType semanticObject)

           Contexts:
               Type returns ClassType

           Constraint:
               (metamodel=[PackageImport|ID]? classname=[EClassifier|ID])

    - #### sequence_VQLImportSection

          protected void sequence_VQLImportSection​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                   VQLImportSection semanticObject)

           Contexts:
               VQLImportSection returns VQLImportSection

           Constraint:
               (packageImport+=PackageImport | patternImport+=PatternImport | importDeclarations+=XImportDeclaration)*

    - #### sequence_VariableReference

          protected void sequence_VariableReference​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                    VariableReference semanticObject)

           Contexts:
               VariableReference returns VariableReference
               ValueReference returns VariableReference
               AnnotationValueReference returns VariableReference

           Constraint:
               ((aggregator?='#'? var=ID) | aggregator?='#')

    - #### sequence_XBooleanLiteral

          protected void sequence_XBooleanLiteral​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                  org.eclipse.xtext.xbase.XBooleanLiteral semanticObject)

           Contexts:
               XBooleanLiteral returns XBooleanLiteral
               XExpression returns XBooleanLiteral
               XAssignment returns XBooleanLiteral
               XAssignment.XBinaryOperation_1_1_0_0_0 returns XBooleanLiteral
               XOrExpression returns XBooleanLiteral
               XOrExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XAndExpression returns XBooleanLiteral
               XAndExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XEqualityExpression returns XBooleanLiteral
               XEqualityExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XRelationalExpression returns XBooleanLiteral
               XRelationalExpression.XInstanceOfExpression_1_0_0_0_0 returns XBooleanLiteral
               XRelationalExpression.XBinaryOperation_1_1_0_0_0 returns XBooleanLiteral
               XOtherOperatorExpression returns XBooleanLiteral
               XOtherOperatorExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XAdditiveExpression returns XBooleanLiteral
               XAdditiveExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XMultiplicativeExpression returns XBooleanLiteral
               XMultiplicativeExpression.XBinaryOperation_1_0_0_0 returns XBooleanLiteral
               XUnaryOperation returns XBooleanLiteral
               XCastedExpression returns XBooleanLiteral
               XCastedExpression.XCastedExpression_1_0_0_0 returns XBooleanLiteral
               XPostfixOperation returns XBooleanLiteral
               XPostfixOperation.XPostfixOperation_1_0_0 returns XBooleanLiteral
               XMemberFeatureCall returns XBooleanLiteral
               XMemberFeatureCall.XAssignment_1_0_0_0_0 returns XBooleanLiteral
               XMemberFeatureCall.XMemberFeatureCall_1_1_0_0_0 returns XBooleanLiteral
               XPrimaryExpression returns XBooleanLiteral
               XLiteral returns XBooleanLiteral
               XParenthesizedExpression returns XBooleanLiteral
               XExpressionOrVarDeclaration returns XBooleanLiteral

           Constraint:
               (isTrue?='true' | isTrue?='TRUE')?

      Overrides:
        `sequence_XBooleanLiteral` in class `org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer`

    - #### sequence_XImportDeclaration

          protected void sequence_XImportDeclaration​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                     org.eclipse.xtext.xtype.XImportDeclaration semanticObject)

           Contexts:
               XImportDeclaration returns XImportDeclaration

           Constraint:
               (
                   (static?='static' extension?='extension'? importedType=[JvmDeclaredType|QualifiedName]) |
                   importedType=[JvmDeclaredType|QualifiedName] |
                   importedNamespace=QualifiedNameWithWildcard
               )

      Overrides:
        `sequence_XImportDeclaration` in class `org.eclipse.xtext.xbase.serializer.AbstractXtypeSemanticSequencer`

    - #### sequence_XNumberLiteral

          protected void sequence_XNumberLiteral​(org.eclipse.xtext.serializer.ISerializationContext context,
                                                 org.eclipse.xtext.xbase.XNumberLiteral semanticObject)

           Contexts:
               XNumberLiteral returns XNumberLiteral
               XExpression returns XNumberLiteral
               XAssignment returns XNumberLiteral
               XAssignment.XBinaryOperation_1_1_0_0_0 returns XNumberLiteral
               XOrExpression returns XNumberLiteral
               XOrExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XAndExpression returns XNumberLiteral
               XAndExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XEqualityExpression returns XNumberLiteral
               XEqualityExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XRelationalExpression returns XNumberLiteral
               XRelationalExpression.XInstanceOfExpression_1_0_0_0_0 returns XNumberLiteral
               XRelationalExpression.XBinaryOperation_1_1_0_0_0 returns XNumberLiteral
               XOtherOperatorExpression returns XNumberLiteral
               XOtherOperatorExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XAdditiveExpression returns XNumberLiteral
               XAdditiveExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XMultiplicativeExpression returns XNumberLiteral
               XMultiplicativeExpression.XBinaryOperation_1_0_0_0 returns XNumberLiteral
               XUnaryOperation returns XNumberLiteral
               XCastedExpression returns XNumberLiteral
               XCastedExpression.XCastedExpression_1_0_0_0 returns XNumberLiteral
               XPostfixOperation returns XNumberLiteral
               XPostfixOperation.XPostfixOperation_1_0_0 returns XNumberLiteral
               XMemberFeatureCall returns XNumberLiteral
               XMemberFeatureCall.XAssignment_1_0_0_0_0 returns XNumberLiteral
               XMemberFeatureCall.XMemberFeatureCall_1_1_0_0_0 returns XNumberLiteral
               XPrimaryExpression returns XNumberLiteral
               XLiteral returns XNumberLiteral
               XParenthesizedExpression returns XNumberLiteral
               XExpressionOrVarDeclaration returns XNumberLiteral

           Constraint:
               value=Number

      Overrides:
        `sequence_XNumberLiteral` in class `org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer`